diff -ur vorbis-prebranch_beta3/configure vorbis-jack_opt/configure
--- vorbis-prebranch_beta3/configure	Thu Oct 19 10:21:53 2000
+++ vorbis-jack_opt/configure	Wed Oct 18 14:37:07 2000
@@ -1547,8 +1547,8 @@
 	*86-*-linux*)
 		DEBUG="-g -Wall -D_REENTRANT -D__NO_MATH_INLINES -fsigned-char"
 		CFLAGS="-O20 -ffast-math -mno-ieee-fp -D_REENTRANT -fsigned-char"
-#              	PROFILE="-Wall -W -pg -O20 -ffast-math -D_REENTRANT -fsigned-char -fno-inline -static"
-		PROFILE="-Wall -W -pg -O20 -ffast-math -mno-ieee-fp -D_REENTRANT -fsigned-char -fno-inline -static"
+#              	PROFILE="-Wall -W -pg -g -O20 -ffast-math -D_REENTRANT -fsigned-char -fno-inline -static"
+		PROFILE="-Wall -W -pg -g -O20 -ffast-math -mno-ieee-fp -D_REENTRANT -fsigned-char -fno-inline -static"
 
 		# glibc < 2.1.3 has a serious FP bug in the math inline header
 		# that will cripple Vorbis.  Look to see if the magic FP stack
diff -ur vorbis-prebranch_beta3/configure.in vorbis-jack_opt/configure.in
--- vorbis-prebranch_beta3/configure.in	Wed Oct 11 20:12:37 2000
+++ vorbis-jack_opt/configure.in	Wed Oct 18 14:36:58 2000
@@ -73,8 +73,8 @@
 	*86-*-linux*)
 		DEBUG="-g -Wall -D_REENTRANT -D__NO_MATH_INLINES -fsigned-char"
 		CFLAGS="-O20 -ffast-math -mno-ieee-fp -D_REENTRANT -fsigned-char"
-#              	PROFILE="-Wall -W -pg -O20 -ffast-math -D_REENTRANT -fsigned-char -fno-inline -static"
-		PROFILE="-Wall -W -pg -O20 -ffast-math -mno-ieee-fp -D_REENTRANT -fsigned-char -fno-inline -static"
+#              	PROFILE="-Wall -W -pg -g -O20 -ffast-math -D_REENTRANT -fsigned-char -fno-inline -static"
+		PROFILE="-Wall -W -pg -g -O20 -ffast-math -mno-ieee-fp -D_REENTRANT -fsigned-char -fno-inline -static"
 
 		# glibc < 2.1.3 has a serious FP bug in the math inline header
 		# that will cripple Vorbis.  Look to see if the magic FP stack
diff -ur vorbis-prebranch_beta3/examples/Makefile.in vorbis-jack_opt/examples/Makefile.in
--- vorbis-prebranch_beta3/examples/Makefile.in	Thu Oct 19 10:22:12 2000
+++ vorbis-jack_opt/examples/Makefile.in	Thu Oct 19 10:19:30 2000
@@ -263,6 +263,33 @@
 	    || cp -p $$d/$$file $(distdir)/$$file || :; \
 	  fi; \
 	done
+chaining_example.o: chaining_example.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	../include/vorbis/vorbisfile.h
+decoder_example.o: decoder_example.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h
+encoder_example.o: encoder_example.c ../include/vorbis/mode_C.h \
+	../include/vorbis/codec.h ../include/vorbis/codebook.h \
+	../include/vorbis/backends.h ../include/vorbis/book/lsp12_0.vqh \
+	../include/vorbis/book/lsp30_0.vqh \
+	../include/vorbis/book/resaux0_128a_192.vqh \
+	../include/vorbis/book/resaux0_1024a_192.vqh \
+	../include/vorbis/book/res0_128a_192_1.vqh \
+	../include/vorbis/book/res0_128a_192_2.vqh \
+	../include/vorbis/book/res0_128a_192_3.vqh \
+	../include/vorbis/book/res0_128a_192_4.vqh \
+	../include/vorbis/book/res0_128a_192_5.vqh \
+	../include/vorbis/book/res0_1024a_192_1.vqh \
+	../include/vorbis/book/res0_1024a_192_2.vqh \
+	../include/vorbis/book/res0_1024a_192_3.vqh \
+	../include/vorbis/book/res0_1024a_192_4.vqh \
+	../include/vorbis/book/res0_1024a_192_5.vqh
+seeking_example.o: seeking_example.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	../include/vorbis/vorbisfile.h ../lib/misc.h
+vorbisfile_example.o: vorbisfile_example.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	../include/vorbis/vorbisfile.h
 
 info-am:
 info: info-am
diff -ur vorbis-prebranch_beta3/lib/Makefile.in vorbis-jack_opt/lib/Makefile.in
--- vorbis-prebranch_beta3/lib/Makefile.in	Thu Oct 19 10:22:09 2000
+++ vorbis-jack_opt/lib/Makefile.in	Thu Oct 19 10:19:27 2000
@@ -246,6 +246,67 @@
 	    || cp -p $$d/$$file $(distdir)/$$file || :; \
 	  fi; \
 	done
+analysis.lo analysis.o : analysis.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	registry.h scales.h os.h
+block.lo block.o : block.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	window.h envelope.h iir.h smallft.h mdct.h lpc.h registry.h \
+	sharedbook.h bookinternal.h misc.h os.h
+codebook.lo codebook.o : codebook.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	scales.h sharedbook.h bookinternal.h misc.h os.h
+envelope.lo envelope.o : envelope.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h os.h \
+	scales.h envelope.h iir.h smallft.h misc.h
+floor0.lo floor0.o : floor0.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	registry.h lpc.h smallft.h lsp.h bookinternal.h sharedbook.h \
+	scales.h misc.h os.h
+iir.lo iir.o : iir.c iir.h
+info.lo info.o : info.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	sharedbook.h bookinternal.h registry.h window.h psy.h smallft.h \
+	misc.h os.h
+lpc.lo lpc.o : lpc.c os.h smallft.h ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h lpc.h \
+	scales.h misc.h
+lsp.lo lsp.o : lsp.c lsp.h os.h misc.h ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	lookup.h scales.h lookup.c lookup_data.h
+mapping0.lo mapping0.o : mapping0.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	bookinternal.h registry.h psy.h smallft.h misc.h os.h lpc.h \
+	lsp.h envelope.h iir.h mdct.h scales.h
+mdct.lo mdct.o : mdct.c mdct.h ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h os.h \
+	misc.h
+psy.lo psy.o : psy.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	masking.h psy.h smallft.h os.h lpc.h scales.h misc.h
+registry.lo registry.o : registry.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	registry.h misc.h
+res0.lo res0.o : res0.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	registry.h bookinternal.h sharedbook.h misc.h os.h
+sharedbook.lo sharedbook.o : sharedbook.c os.h ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	scales.h sharedbook.h
+smallft.lo smallft.o : smallft.c smallft.h ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	misc.h
+synthesis.lo synthesis.o : synthesis.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	registry.h misc.h os.h
+time0.lo time0.o : time0.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	registry.h misc.h
+vorbisfile.lo vorbisfile.o : vorbisfile.c ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h \
+	../include/vorbis/vorbisfile.h os.h misc.h
+window.lo window.o : window.c os.h misc.h ../include/vorbis/codec.h \
+	../include/vorbis/codebook.h ../include/vorbis/backends.h
 
 info-am:
 info: info-am
diff -ur vorbis-prebranch_beta3/lib/lsp.c vorbis-jack_opt/lib/lsp.c
--- vorbis-prebranch_beta3/lib/lsp.c	Wed Oct 11 20:12:53 2000
+++ vorbis-jack_opt/lib/lsp.c	Wed Oct 18 14:47:04 2000
@@ -12,7 +12,7 @@
  ********************************************************************
 
   function: LSP (also called LSF) conversion routines
-  last mod: $Id: lsp.c,v 1.10 2000/10/12 03:12:53 xiphmont Exp $
+  last mod: $Id: lsp.c,v 1.11 2000/10/18 21:27:15 jack Exp $
 
   The LSP generation code is taken (with minimal modification) from
   "On the Computation of the LSP Frequencies" by Joseph Rothweiler
@@ -69,23 +69,29 @@
 
   i=0;
   while(i<n){
-    int j,k=map[i];
+    int j=0,k=map[i];
     int qexp;
     float p=.7071067812;
     float q=.7071067812;
     float w=vorbis_coslook(wdel*k);
+    float *ftmp=lsp;
+    int c=m>>1;
 
-    for(j=0;j<m;j+=2)    p *= lsp[j]-w;
-    for(j=1;j<m;j+=2)    q *= lsp[j]-w;
-
+    do{
+      p*=ftmp[0]-w;
+      q*=ftmp[1]-w;
+      ftmp+=2;
+    }while(--c);
+    
     q=frexp(p*p*(1.+w)+q*q*(1.-w),&qexp);
     q=vorbis_fromdBlook(amp*             
 			vorbis_invsqlook(q)*
 			vorbis_invsq2explook(qexp+m)- 
 			ampoffset);
 
-    curve[i++]=q;
-    while(map[i]==k)curve[i++]=q;
+    do{
+      curve[i++]=q;
+    }while(map[i]==k);
   }
 }
 
diff -ur vorbis-prebranch_beta3/lib/mapping0.c vorbis-jack_opt/lib/mapping0.c
--- vorbis-prebranch_beta3/lib/mapping0.c	Wed Oct 11 20:12:53 2000
+++ vorbis-jack_opt/lib/mapping0.c	Wed Oct 18 16:46:58 2000
@@ -355,12 +355,15 @@
   /* window the data */
   for(i=0;i<vi->channels;i++){
     float *pcm=vb->pcm[i];
-    if(nonzero[i])
-      for(j=0;j<n;j++)
+    if(nonzero[i]){
+      j=n-1;
+      do{
 	pcm[j]*=window[j];
-    else
+      }while(j--);
+    }else{
       for(j=0;j<n;j++)
 	pcm[j]=0.;
+    }
     _analysis_output("final",seq++,pcm,n,0,0);
   }
 	    
diff -ur vorbis-prebranch_beta3/lib/mdct.c vorbis-jack_opt/lib/mdct.c
--- vorbis-prebranch_beta3/lib/mdct.c	Wed Oct 11 20:12:53 2000
+++ vorbis-jack_opt/lib/mdct.c	Wed Oct 18 18:15:52 2000
@@ -107,22 +107,17 @@
     float *xB=x;
     float *w2=w+n4;
     float *A=init->trig+n2;
-
-    for(i=0;i<n4;){
-      float x0=*xA - *xB;
-      float x1;
+    float x0,x1;
+    i=0;
+    do{
+      x0=*xA - *xB;
       w2[i]=    *xA++ + *xB++;
-
-
       x1=       *xA - *xB;
       A-=4;
-
       w[i++]=   x0 * A[0] + x1 * A[1];
       w[i]=     x1 * A[0] - x0 * A[1];
-
       w2[i++]=  *xA++ + *xB++;
-
-    }
+    }while(i<n4);
   }
 
   /* step 3 */
@@ -141,10 +136,66 @@
 	int w2=w1-(k0>>1);
 	float AEv= A[0],wA;
 	float AOv= A[1],wB;
+        int blah=i;
 	wbase-=2;
 
 	k0++;
-	for(s=0;s<(2<<i);s++){
+        blah--;
+        if(blah > 0) {
+          s=2<<blah;
+          s>>=1;
+          do{
+          wB     =w[w1]   -w[w2];
+          x[w1]  =w[w1]   +w[w2];
+          
+          wA     =w[++w1] -w[++w2];
+          x[w1]  =w[w1]   +w[w2];
+          
+          x[w2]  =wA*AEv  - wB*AOv;
+          x[w2-1]=wB*AEv  + wA*AOv;
+          
+          w1-=k0;
+          w2-=k0;
+
+          wB     =w[w1]   -w[w2];
+          x[w1]  =w[w1]   +w[w2];
+          
+          wA     =w[++w1] -w[++w2];
+          x[w1]  =w[w1]   +w[w2];
+          
+          x[w2]  =wA*AEv  - wB*AOv;
+          x[w2-1]=wB*AEv  + wA*AOv;
+          
+          w1-=k0;
+          w2-=k0;
+
+          wB     =w[w1]   -w[w2];
+          x[w1]  =w[w1]   +w[w2];
+          
+          wA     =w[++w1] -w[++w2];
+          x[w1]  =w[w1]   +w[w2];
+          
+          x[w2]  =wA*AEv  - wB*AOv;
+          x[w2-1]=wB*AEv  + wA*AOv;
+          
+          w1-=k0;
+          w2-=k0;
+
+          wB     =w[w1]   -w[w2];
+          x[w1]  =w[w1]   +w[w2];
+          
+          wA     =w[++w1] -w[++w2];
+          x[w1]  =w[w1]   +w[w2];
+          
+          x[w2]  =wA*AEv  - wB*AOv;
+          x[w2-1]=wB*AEv  + wA*AOv;
+          
+          w1-=k0;
+          w2-=k0;
+          }while(--s); 
+        } else {
+        s=2<<i;
+	do{
 	  wB     =w[w1]   -w[w2];
 	  x[w1]  =w[w1]   +w[w2];
 
@@ -156,7 +207,8 @@
 
 	  w1-=k0;
 	  w2-=k0;
-	}
+	}while(--s);
+        }
 	k0--;
 
 	A+=k1;
@@ -174,7 +226,8 @@
     int *bit=init->bitrev;
     float *x1=x;
     float *x2=x+n2-1;
-    for(i=0;i<n8;i++){
+    i=n8-1;
+    do{
       int t1=*bit++;
       int t2=*bit++;
 
@@ -192,7 +245,7 @@
       *x2--=(-wD+wBCO-wACE)*.5;
       *x1++=( wD+wBCO-wACE)*.5; 
       *x2--=( wC-wACO-wBCE)*.5;
-    }
+    }while(i--);
   }
   return(x);
 }
diff -ur vorbis-prebranch_beta3/lib/vorbisfile.c vorbis-jack_opt/lib/vorbisfile.c
--- vorbis-prebranch_beta3/lib/vorbisfile.c	Fri Oct 13 12:48:03 2000
+++ vorbis-jack_opt/lib/vorbisfile.c	Wed Oct 18 22:06:59 2000
@@ -1067,6 +1067,14 @@
   return 0;
 }
 
+inline static int f2i(double f)
+{
+  int i;
+  asm("fistl %0" : "=m"(i) : "t"(f));
+  return i;
+}
+
+
 /* up to this point, everything could more or less hide the multiple
    logical bitstream nature of chaining from the toplevel application
    if the toplevel application didn't particularly care.  However, at
@@ -1121,7 +1129,7 @@
 	    int off=(sgned?0:128);
 	    for(j=0;j<samples;j++)
 	      for(i=0;i<channels;i++){
-		val=(int)(pcm[i][j]*128. + 0.5);
+		val=f2i(pcm[i][j]*128.);
 		if(val>127)val=127;
 		else if(val<-128)val=-128;
 		*buffer++=val+off;
@@ -1133,21 +1141,22 @@
 	      if(sgned){
 		for(i=0;i<channels;i++) { /* It's faster in this order */
 		  float *src=pcm[i];
-		  short *dest=((short *)buffer)+i;
-		  for(j=0;j<samples;j++) {
-		    val=(int)(src[j]*32768. + 0.5);
+		  short *dest=((short *)buffer)+i+(samples)*channels;
+                  j=samples-1;
+                  do{
+		    dest-=channels;
+		    val=f2i(src[j]*32768.);
 		    if(val>32767)val=32767;
 		    else if(val<-32768)val=-32768;
 		    *dest=val;
-		    dest+=channels;
-		  }
+		  }while(j--);
 		}
 	      }else{
 		for(i=0;i<channels;i++) {
 		  float *src=pcm[i];
 		  short *dest=((short *)buffer)+i;
 		  for(j=0;j<samples;j++) {
-		    val=(int)(src[j]*32768. + 0.5);
+		    val=f2i(src[j]*32768.);
 		    if(val>32767)val=32767;
 		    else if(val<-32768)val=-32768;
 		    *dest=val+off;
@@ -1158,7 +1167,7 @@
 	    }else if(bigendianp){
 	      for(j=0;j<samples;j++)
 		for(i=0;i<channels;i++){
-		  val=(int)(pcm[i][j]*32768. + 0.5);
+		  val=f2i(pcm[i][j]*32768.);
 		  if(val>32767)val=32767;
 		  else if(val<-32768)val=-32768;
 		  val+=off;
@@ -1169,7 +1178,7 @@
 	      int val;
 	      for(j=0;j<samples;j++)
 	 	for(i=0;i<channels;i++){
-		  val=(int)(pcm[i][j]*32768. + 0.5);
+		  val=f2i(pcm[i][j]*32768.);
 		  if(val>32767)val=32767;
 		  else if(val<-32768)val=-32768;
 		  val+=off;

